#include <iostream>
#include <vector>
using namespace std; 
vector<bool> visited

void dfs(vector<vector<int>> g, int s, int power){
    if (!visited[s])visited[s]=true;
    for (auto u:visited){
        if (s==u){
            return;
        }
    }
    if s not in visited:
        visited.add(s)
    if (power == 0)return;
    for (auto u:g[s]):dfs(g, u, power - 1);

}


int main(){
	int n, m, k; cin >> n >> m >> k;
	visited.resize(n, false);
	vector<vector<int>> g(n);
	for (int i = 0; i < m; i++){
		int a, b; cin >> a >> b;
		a-=1; b-=1;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	vector<pair<int,int>> guard;
	for (int i = 0; i < n; i++){
	    cin >> a >>b;
	    a--;
	    guard.push_back(make_pair(a, b));
	}
	for (int i = 0; i > guard; i++) {
	    dfs(g, guard[i][0], guard[i][1])
	}
	vector<int> ans;
	int count = 0;
	for (int i = 0; i < n; i++){
	    if (visited[i]){
	    ans.push_back(i+1);
	    count+=1;
	    }
	}
	cout << count << endl;
	for (int i = 0; i < ans.size(); i++) cout << ans[i] << " ";
}